Index: /XIOS/trunk/src/transformation/axis_algorithm_temporal_splitting.hpp
===================================================================
--- /XIOS/trunk/src/transformation/axis_algorithm_temporal_splitting.hpp	(revision 1537)
+++ /XIOS/trunk/src/transformation/axis_algorithm_temporal_splitting.hpp	(revision 1537)
@@ -0,0 +1,52 @@
+/*!
+   \file axis_algorithm_reduce_domain.hpp
+   \author Ha NGUYEN
+   \since 23 June 2016
+   \date 23 June 2016
+
+   \brief Algorithm for reduce an axis to a axis
+ */
+#ifndef __XIOS_AXIS_ALGORITHM_TEMPORAL_SPLITTING_HPP__
+#define __XIOS_AXIS_ALGORITHM_TEMPORAL_SPLITTING_HPP__
+
+#include "axis_algorithm_transformation.hpp"
+#include "transformation.hpp"
+
+namespace xios {
+
+class CAxis;
+class CScalar;
+class CTemporalSplitting;
+
+
+
+/*!
+  \class CAxisAlgorithmExtractDomain
+  Extract a domain to an axis
+*/
+class CAxisAlgorithmTemporalSplitting : public CAxisAlgorithmTransformation
+{
+public:
+  CAxisAlgorithmTemporalSplitting(CAxis* axisDestination, CScalar* scalarSource, CTemporalSplitting* algo);
+
+  virtual ~CAxisAlgorithmTemporalSplitting();
+
+  static bool registerTrans();
+
+protected:
+  void computeIndexSourceMapping_(const std::vector<CArray<double,1>* >& dataAuxInputs);
+
+private:
+  static CGenericAlgorithmTransformation* create(CGrid* gridDst, CGrid* gridSrc,
+                                                CTransformation<CAxis>* transformation,
+                                                int elementPositionInGrid,
+                                                std::map<int, int>& elementPositionInGridSrc2ScalarPosition,
+                                                std::map<int, int>& elementPositionInGridSrc2AxisPosition,
+                                                std::map<int, int>& elementPositionInGridSrc2DomainPosition,
+                                                std::map<int, int>& elementPositionInGridDst2ScalarPosition,
+                                                std::map<int, int>& elementPositionInGridDst2AxisPosition,
+                                                std::map<int, int>& elementPositionInGridDst2DomainPosition);
+};
+
+}
+#endif // __XIOS_AXIS_ALGORITHM_TEMPORAL_SPLITTING_HPP__
Index: /XIOS/trunk/src/transformation/axis_algorithm_transformation.cpp
===================================================================
--- /XIOS/trunk/src/transformation/axis_algorithm_transformation.cpp	(revision 1536)
+++ /XIOS/trunk/src/transformation/axis_algorithm_transformation.cpp	(revision 1537)
@@ -19,5 +19,5 @@
 
 CAxisAlgorithmTransformation::CAxisAlgorithmTransformation(CAxis* axisDestination, CAxis* axisSource)
- : CGenericAlgorithmTransformation(), axisDest_(axisDestination), axisSrc_(axisSource), domainSrc_(0)
+ : CGenericAlgorithmTransformation(), axisDest_(axisDestination), axisSrc_(axisSource), domainSrc_(0),scalarSrc_(0)
 {
   axisDestGlobalSize_ = axisDestination->n_glo.getValue();
@@ -30,5 +30,5 @@
 
 CAxisAlgorithmTransformation::CAxisAlgorithmTransformation(CAxis* axisDestination, CDomain* domainSource)
- : CGenericAlgorithmTransformation(), axisDest_(axisDestination), axisSrc_(0), domainSrc_(domainSource)
+ : CGenericAlgorithmTransformation(), axisDest_(axisDestination), axisSrc_(0), domainSrc_(domainSource),scalarSrc_(0)
 {
   axisDestGlobalSize_ = axisDestination->n_glo.getValue();
@@ -40,4 +40,14 @@
 }
 
+CAxisAlgorithmTransformation::CAxisAlgorithmTransformation(CAxis* axisDestination, CScalar* scalarSource)
+ : CGenericAlgorithmTransformation(), axisDest_(axisDestination), axisSrc_(0), domainSrc_(0), scalarSrc_(scalarSource)
+{
+  axisDestGlobalSize_ = axisDestination->n_glo.getValue();
+  int niDest = axisDestination->n.getValue();
+  int ibeginDest = axisDestination->begin.getValue();
+
+  for (int idx = 0; idx < niDest; ++idx)
+    if ((axisDestination->mask)(idx)) axisDestGlobalIndex_.push_back(ibeginDest+idx);
+}
 CAxisAlgorithmTransformation::~CAxisAlgorithmTransformation()
 {
@@ -64,21 +74,47 @@
   size_t globalIndex;
   int nIndexSize = 0;
-  if (2 == elementType) nIndexSize = domainSrc_->i_index.numElements();
-  else if (1 == elementType) nIndexSize = axisSrc_->index.numElements();
+  CArray<bool,1>* ptLocalMask ;
+  CArray<bool,1> scalarMask(1) ;
+  scalarMask=true ;
+  
+  if (2 == elementType) 
+  {
+    nIndexSize = domainSrc_->i_index.numElements();
+    ptLocalMask=&(domainSrc_->localMask) ;
+  }
+  else if (1 == elementType)
+  {
+     nIndexSize = axisSrc_->index.numElements();
+     ptLocalMask=&(axisSrc_->mask) ;
+  }
+  else
+  {
+     nIndexSize=1  ; //  scalar
+     ptLocalMask=&scalarMask ;
+  }
+  CArray<bool,1>& localMask=*ptLocalMask ;
+  
   CClientClientDHTInt::Index2VectorInfoTypeMap globalIndex2ProcRank;
   globalIndex2ProcRank.rehash(std::ceil(nIndexSize/globalIndex2ProcRank.max_load_factor()));
   for (int idx = 0; idx < nIndexSize; ++idx)
   {
-    if (2 == elementType)
+    if (localMask(idx))
     {
-      globalIndex = domainSrc_->i_index(idx) + domainSrc_->j_index(idx) * domainSrc_->ni_glo;
+      if (2 == elementType) // domain
+      {
+       globalIndex = domainSrc_->i_index(idx) + domainSrc_->j_index(idx) * domainSrc_->ni_glo;
+      }
+      else if (1 == elementType) // axis
+      {
+        globalIndex = axisSrc_->index(idx);
+      }
+      else // scalar
+      {
+        globalIndex = 0;
+      }
+     
+      globalIndex2ProcRank[globalIndex].resize(1);
+      globalIndex2ProcRank[globalIndex][0] = clientRank;
     }
-    else if (1 == elementType)
-    {
-      globalIndex = axisSrc_->index(idx);
-    }
-
-    globalIndex2ProcRank[globalIndex].resize(1);
-    globalIndex2ProcRank[globalIndex][0] = clientRank;
   }
 
Index: /XIOS/trunk/src/transformation/axis_algorithm_transformation.hpp
===================================================================
--- /XIOS/trunk/src/transformation/axis_algorithm_transformation.hpp	(revision 1536)
+++ /XIOS/trunk/src/transformation/axis_algorithm_transformation.hpp	(revision 1537)
@@ -17,5 +17,5 @@
 class CAxis;
 class CDomain;
-
+class CScalar;
 /*!
   \class CAxisAlgorithmTransformation
@@ -27,4 +27,5 @@
   CAxisAlgorithmTransformation(CAxis* axisDestination, CAxis* axisSource);
   CAxisAlgorithmTransformation(CAxis* axisDestination, CDomain* domainSource);
+  CAxisAlgorithmTransformation(CAxis* axisDestination, CScalar* scalarSource);
 
   virtual ~CAxisAlgorithmTransformation();
@@ -52,4 +53,8 @@
   //! Domain on grid source
   CDomain* domainSrc_;
+
+  //! Scalar on grid source
+
+  CScalar* scalarSrc_;
 };
 
Index: /XIOS/trunk/src/transformation/axis_algorithm_zoom.cpp
===================================================================
--- /XIOS/trunk/src/transformation/axis_algorithm_zoom.cpp	(revision 1536)
+++ /XIOS/trunk/src/transformation/axis_algorithm_zoom.cpp	(revision 1537)
@@ -44,5 +44,5 @@
   zoomBegin_ = zoomAxis->begin.getValue();
   zoomSize_  = zoomAxis->n.getValue();
-  zoomEnd_   = zoomBegin_ + zoomSize_ - 1;  
+  zoomEnd_   = zoomBegin_ + zoomSize_ - 1;
 
   if (zoomSize_ > axisSource->n_glo.getValue())
@@ -63,4 +63,5 @@
     std::sort(zoomIndex_.begin(), zoomIndex_.end());
   }
+
 }
 
@@ -70,10 +71,7 @@
 void CAxisAlgorithmZoom::computeIndexSourceMapping_(const std::vector<CArray<double,1>* >& dataAuxInputs)
 {
-  this->transformationMapping_.resize(1);
-  this->transformationWeight_.resize(1);
-
-  TransformationIndexMap& transMap = this->transformationMapping_[0];
-  TransformationWeightMap& transWeight = this->transformationWeight_[0];
-
+  // We use all index of source and destination to calculate the mapping index of zoom.
+  // The server who receives the "zoomed" fields will decide whether it will forward these fields or write "real zoomed" fields into file
+  // That means servers need to change to cover this problem.
   StdSize niSource = axisSrc_->n.getValue();
   StdSize ibeginSource = axisSrc_->begin.getValue();
@@ -84,4 +82,10 @@
   StdSize ni = iend + 1 - ibegin;
   if (iend < ibegin) ni = 0;
+
+  this->transformationMapping_.resize(1);
+  this->transformationWeight_.resize(1);
+
+  TransformationIndexMap& transMap = this->transformationMapping_[0];
+  TransformationWeightMap& transWeight = this->transformationWeight_[0];
 
   if (!zoomIndex_.empty())
@@ -106,5 +110,5 @@
 
   updateZoom();
-  updateAxisDestinationMask();
+  // updateAxisDestinationMask();
 }
 
@@ -128,18 +132,18 @@
 correct index be extracted
 */
-void CAxisAlgorithmZoom::updateAxisDestinationMask()
-{
-  StdSize niMask = axisDest_->mask.numElements();
-  StdSize iBeginMask = axisDest_->begin.getValue();
-  StdSize globalIndexMask = 0;
-  TransformationIndexMap& transMap = this->transformationMapping_[0];
-  TransformationIndexMap::const_iterator ite = (transMap).end();
-  for (StdSize idx = 0; idx < niMask; ++idx)
-  {
-    globalIndexMask = iBeginMask + idx;
-    if (transMap.find(globalIndexMask) == ite)
-      (axisDest_->mask)(idx) = false;
-  }
-}
+// void CAxisAlgorithmZoom::updateAxisDestinationMask()
+// {
+//   StdSize niMask = axisDest_->mask.numElements();
+//   StdSize iBeginMask = axisDest_->begin.getValue();
+//   StdSize globalIndexMask = 0;
+//   TransformationIndexMap& transMap = this->transformationMapping_[0];
+//   TransformationIndexMap::const_iterator ite = (transMap).end();
+//   for (StdSize idx = 0; idx < niMask; ++idx)
+//   {
+//     globalIndexMask = iBeginMask + idx;
+//     if (transMap.find(globalIndexMask) == ite)
+//       (axisDest_->mask)(idx) = false;
+//   }
+// }
 
 }
Index: /XIOS/trunk/src/transformation/axis_algorithm_zoom.hpp
===================================================================
--- /XIOS/trunk/src/transformation/axis_algorithm_zoom.hpp	(revision 1536)
+++ /XIOS/trunk/src/transformation/axis_algorithm_zoom.hpp	(revision 1537)
@@ -35,5 +35,5 @@
 
 private:
-  void updateAxisDestinationMask();
+  // void updateAxisDestinationMask();
   void updateZoom();
 
Index: /XIOS/trunk/src/transformation/domain_algorithm_expand.cpp
===================================================================
--- /XIOS/trunk/src/transformation/domain_algorithm_expand.cpp	(revision 1536)
+++ /XIOS/trunk/src/transformation/domain_algorithm_expand.cpp	(revision 1537)
@@ -161,4 +161,5 @@
   else domainDestination->domain_ref.setValue(domainDstRef);
 
+  
   // Here are attributes of source need tranfering
   int niGloSrc = domainSource->ni_glo;
@@ -167,5 +168,5 @@
   int njSrc = domainSource->nj, jbegin = domainSource->jbegin;
   int dataDimSrc = domainSource->data_dim;
-  CArray<bool,1>& mask_1d_src = domainSource->mask_1d;
+  CArray<bool,1>& mask_1d_src = domainSource->domainMask;
   CArray<int,1>& i_index_src = domainSource->i_index;
   CArray<int,1>& j_index_src = domainSource->j_index;
@@ -174,6 +175,6 @@
   int data_i_begin_src = domainSource->data_ibegin;
   int data_j_begin_src = domainSource->data_jbegin;
-  CArray<double,1>& lon_src = domainSource->lonvalue_client;
-  CArray<double,1>& lat_src = domainSource->latvalue_client;
+  CArray<double,1>& lon_src = domainSource->lonvalue;
+  CArray<double,1>& lat_src = domainSource->latvalue;
 
   // We need to generate boundary for longitude and latitude
@@ -230,5 +231,5 @@
   domainDestination->global_zoom_nj.setValue(domainSource->global_zoom_nj+2);
 
-  CArray<bool,1>& mask_1d_dst = domainDestination->mask_1d;
+  CArray<bool,1>& mask_1d_dst = domainDestination->domainMask;
   CArray<int,1>& i_index_dst  = domainDestination->i_index;
   CArray<int,1>& j_index_dst  = domainDestination->j_index;  
@@ -252,10 +253,10 @@
   CArray<int,1> data_j_index_dst_full(newNbLocalDst);
 
-  domainDestination->lonvalue_client.resizeAndPreserve(newNbLocalDst);  
-  domainDestination->latvalue_client.resizeAndPreserve(newNbLocalDst);
+  domainDestination->lonvalue.resizeAndPreserve(newNbLocalDst);
+  domainDestination->latvalue.resizeAndPreserve(newNbLocalDst);
   domainDestination->bounds_lon_1d.resizeAndPreserve(nVertex, newNbLocalDst);
   domainDestination->bounds_lat_1d.resizeAndPreserve(nVertex, newNbLocalDst);
-  CArray<double,1>& lon_dst   = domainDestination->lonvalue_client;
-  CArray<double,1>& lat_dst   = domainDestination->latvalue_client;
+  CArray<double,1>& lon_dst   = domainDestination->lonvalue;
+  CArray<double,1>& lat_dst   = domainDestination->latvalue;
   CArray<double,2>& bounds_lon_dst = domainDestination->bounds_lon_1d;
   CArray<double,2>& bounds_lat_dst = domainDestination->bounds_lat_1d;
@@ -452,5 +453,7 @@
      domainDestination->latvalue_1d = (lat_dst);
   }
-
+   domainDestination->mask_1d.resize(domainDestination->domainMask.numElements()) ;
+   domainDestination->mask_1d=domainDestination->domainMask ;
+   domainDestination->computeLocalMask() ;
 }
 
@@ -484,5 +487,5 @@
   // Now extend domain destination
   int niGlob = domainSource->ni_glo;
-  CArray<bool,1>& mask_1d_src = domainSource->mask_1d;
+  CArray<bool,1>& mask_1d_src = domainSource->domainMask;
   CArray<int,1>& i_index_src = domainSource->i_index;
   CArray<double,1>& lon_src = domainSource->lonvalue_1d;
@@ -507,5 +510,5 @@
   }
 
-  CArray<bool,1>& mask_1d_dst = domainDestination->mask_1d;
+  CArray<bool,1>& mask_1d_dst = domainDestination->domainMask;
   CArray<int,1>& i_index_dst = domainDestination->i_index;
   CArray<int,1>& j_index_dst = domainDestination->j_index;
@@ -664,4 +667,7 @@
   // Update ni
   domainDestination->ni.setValue(newNbLocalDst);
+  domainDestination->mask_1d.resize(domainDestination->domainMask.numElements()) ;
+  domainDestination->mask_1d=domainDestination->domainMask ;
+  domainDestination->computeLocalMask() ;
 }
 
Index: /XIOS/trunk/src/transformation/domain_algorithm_generate_rectilinear.hpp
===================================================================
--- /XIOS/trunk/src/transformation/domain_algorithm_generate_rectilinear.hpp	(revision 1536)
+++ /XIOS/trunk/src/transformation/domain_algorithm_generate_rectilinear.hpp	(revision 1537)
@@ -20,6 +20,6 @@
 /*!
   \class CDomainAlgorithmGenerateRectilinear
-  Generate a rectilinear domain and fill in necessary its attributes automatically
-  A new rectilinear domain will also be distributed automatically among the processes.
+  Generate a rectilinear or CURVILINEAR domain and fill in necessary its attributes automatically
+  A new rectilinear (or CURVILINEAR) domain will also be distributed automatically among the processes.
   The number of processes is deduced from the distribution of the grid source.
 */
Index: /XIOS/trunk/src/transformation/domain_algorithm_interpolate.cpp
===================================================================
--- /XIOS/trunk/src/transformation/domain_algorithm_interpolate.cpp	(revision 1536)
+++ /XIOS/trunk/src/transformation/domain_algorithm_interpolate.cpp	(revision 1537)
@@ -52,4 +52,12 @@
   CContext* context = CContext::getCurrent();
   interpDomain_->checkValid(domainSource);
+
+  detectMissingValue = interpDomain_->detect_missing_value ;
+  renormalize = interpDomain_->renormalize ;
+  quantity = interpDomain_->quantity ;
+
+  if (interpDomain_->read_write_convention == CInterpolateDomain::read_write_convention_attr::fortran) fortranConvention=true ;
+  else fortranConvention=false ;
+  
   fileToReadWrite_ = "xios_interpolation_weights_";
 
@@ -99,12 +107,5 @@
   std::vector<double> srcPole(3,0), dstPole(3,0);
   int orderInterp = interpDomain_->order.getValue();
-  bool renormalize ;
-  bool quantity ;
-
-  if (interpDomain_->renormalize.isEmpty()) renormalize=true;
-  else renormalize = interpDomain_->renormalize;
-
-  if (interpDomain_->quantity.isEmpty()) quantity=false;
-  else quantity = interpDomain_->quantity;
+
 
   const double poleValue = 90.0;
@@ -453,5 +454,5 @@
         recvTemp[recvSourceIndexBuff[idx]] += recvSourceWeightBuff[idx]/nbGlobalPointOnPole;
       else
-        recvTemp[recvSourceIndexBuff[idx]] = 0.0;
+        recvTemp[recvSourceIndexBuff[idx]] = recvSourceWeightBuff[idx]/nbGlobalPointOnPole;
     }
 
@@ -473,5 +474,5 @@
 void CDomainAlgorithmInterpolate::computeIndexSourceMapping_(const std::vector<CArray<double,1>* >& dataAuxInputs)
 {
-  if (readFromFile_ && !writeToFile_)  
+  if (readFromFile_)  
     readRemapInfo();
   else
@@ -563,5 +564,5 @@
   }
 
-  domainIndexClientClientMapping.computeServerIndexMapping(globalIndexInterp);
+  domainIndexClientClientMapping.computeServerIndexMapping(globalIndexInterp, client->serverSize);
   const CClientServerMapping::GlobalIndexMap& globalIndexInterpSendToClient = domainIndexClientClientMapping.getGlobalIndexOnServer();
 
@@ -770,4 +771,6 @@
 
   int index = 0;
+  int indexOffset=0 ;
+  if (fortranConvention) indexOffset=1 ;
   for (it = itb; it !=ite; ++it)
   {
@@ -775,6 +778,6 @@
     for (int idx = 0; idx < tmp.size(); ++idx)
     {
-      dst_idx(index) = it->first + 1;
-      src_idx(index) = tmp[idx].first + 1;
+      dst_idx(index) = it->first + indexOffset;
+      src_idx(index) = tmp[idx].first + indexOffset;
       weights(index) = tmp[idx].second;
       ++index;
@@ -838,4 +841,5 @@
   size_t nbWeightGlo ;
 
+
   CContext* context = CContext::getCurrent();
   CContextClient* client=context->client;
@@ -843,4 +847,12 @@
   int clientSize = client->clientSize;
 
+
+  {
+    ifstream f(filename.c_str());
+    if (!f.good()) ERROR("void CDomainAlgorithmInterpolate::readInterpolationInfo",
+                      << "Attempt to read file weight :"  << filename << " which doesn't seem to exist." << std::endl
+                      << "Please check this file ");
+  }
+                  
   nc_open(filename.c_str(),NC_NOWRITE, &ncid) ;
   nc_inq_dimid(ncid,"n_weight",&weightDimId) ;
@@ -877,7 +889,76 @@
   nc_get_vara_long(ncid, dstIndexId, &start, &nbWeight, dstIndex) ;
 
-  for(size_t ind=0; ind<nbWeight;++ind)
-    interpMapValue[dstIndex[ind]-1].push_back(make_pair(srcIndex[ind]-1,weight[ind]));
-}
-
-}
+  int indexOffset=0 ;
+  if (fortranConvention) indexOffset=1 ;
+    for(size_t ind=0; ind<nbWeight;++ind)
+      interpMapValue[dstIndex[ind]-indexOffset].push_back(make_pair(srcIndex[ind]-indexOffset,weight[ind]));
+ }
+
+void CDomainAlgorithmInterpolate::apply(const std::vector<std::pair<int,double> >& localIndex,
+                                            const double* dataInput,
+                                            CArray<double,1>& dataOut,
+                                            std::vector<bool>& flagInitial,
+                                            bool ignoreMissingValue, bool firstPass  )
+{
+  int nbLocalIndex = localIndex.size();   
+  double defaultValue = std::numeric_limits<double>::quiet_NaN();
+   
+  if (detectMissingValue)
+  {
+     if (firstPass && renormalize)
+     {
+       renormalizationFactor.resize(dataOut.numElements()) ;
+       renormalizationFactor=1 ;
+     }
+
+    if (firstPass)
+    {
+      allMissing.resize(dataOut.numElements()) ;
+      allMissing=true ;
+    }
+
+    for (int idx = 0; idx < nbLocalIndex; ++idx)
+    {
+      if (NumTraits<double>::isNan(*(dataInput + idx)))
+      {
+        allMissing(localIndex[idx].first) = allMissing(localIndex[idx].first) && true;
+        if (renormalize) renormalizationFactor(localIndex[idx].first)-=localIndex[idx].second ;
+      }
+      else
+      {
+        dataOut(localIndex[idx].first) += *(dataInput + idx) * localIndex[idx].second;
+        allMissing(localIndex[idx].first) = allMissing(localIndex[idx].first) && false; // Reset flag to indicate not all data source are nan
+      }
+    }
+
+  }
+  else
+  {
+    for (int idx = 0; idx < nbLocalIndex; ++idx)
+    {
+      dataOut(localIndex[idx].first) += *(dataInput + idx) * localIndex[idx].second;
+    }
+  }
+}
+
+void CDomainAlgorithmInterpolate::updateData(CArray<double,1>& dataOut)
+{
+  if (detectMissingValue)
+  {
+    double defaultValue = std::numeric_limits<double>::quiet_NaN();
+    size_t nbIndex=dataOut.numElements() ; 
+
+    for (int idx = 0; idx < nbIndex; ++idx)
+    {
+      if (allMissing(idx)) dataOut(idx) = defaultValue; // If all data source are nan then data destination must be nan
+    }
+    
+    if (renormalize)
+    {
+      if (renormalizationFactor.numElements()>0) dataOut/=renormalizationFactor ; // In some case, process doesn't received any data for interpolation (mask)
+                                                                                 // so renormalizationFactor is not initialized
+    }
+  }
+}
+
+}
Index: /XIOS/trunk/src/transformation/domain_algorithm_interpolate.hpp
===================================================================
--- /XIOS/trunk/src/transformation/domain_algorithm_interpolate.hpp	(revision 1536)
+++ /XIOS/trunk/src/transformation/domain_algorithm_interpolate.hpp	(revision 1537)
@@ -31,4 +31,11 @@
   virtual ~CDomainAlgorithmInterpolate() {}
 
+  virtual void apply(const std::vector<std::pair<int,double> >& localIndex,
+                     const double* dataInput,
+                     CArray<double,1>& dataOut,
+                     std::vector<bool>& flagInitial,                     
+                     bool ignoreMissingValue, bool firstPass);
+  virtual void updateData(CArray<double,1>& dataOut);
+
   static bool registerTrans();
 protected:
@@ -47,8 +54,15 @@
 
 private:
+  CArray<double,1> renormalizationFactor ;
+  CArray<bool,1> allMissing ;
+  bool detectMissingValue ;
+  bool renormalize ;
+  bool quantity ;
+  
   CInterpolateDomain* interpDomain_;
   bool writeToFile_;
   bool readFromFile_;
   StdString fileToReadWrite_;
+  bool fortranConvention ;
 
   // class WriteNetCdf;
Index: /XIOS/trunk/src/transformation/domain_algorithm_reorder.cpp
===================================================================
--- /XIOS/trunk/src/transformation/domain_algorithm_reorder.cpp	(revision 1537)
+++ /XIOS/trunk/src/transformation/domain_algorithm_reorder.cpp	(revision 1537)
@@ -0,0 +1,130 @@
+/*!
+   \file domain_algorithm_reorder.cpp
+   \brief Algorithm for reorder a domain.
+ */
+#include "domain_algorithm_reorder.hpp"
+#include "reorder_domain.hpp"
+#include "domain.hpp"
+#include "grid.hpp"
+#include "grid_transformation_factory_impl.hpp"
+
+namespace xios {
+CGenericAlgorithmTransformation* CDomainAlgorithmReorder::create(CGrid* gridDst, CGrid* gridSrc,
+                                                             CTransformation<CDomain>* transformation,
+                                                             int elementPositionInGrid,
+                                                             std::map<int, int>& elementPositionInGridSrc2ScalarPosition,
+                                                             std::map<int, int>& elementPositionInGridSrc2AxisPosition,
+                                                             std::map<int, int>& elementPositionInGridSrc2DomainPosition,
+                                                             std::map<int, int>& elementPositionInGridDst2ScalarPosition,
+                                                             std::map<int, int>& elementPositionInGridDst2AxisPosition,
+                                                             std::map<int, int>& elementPositionInGridDst2DomainPosition)
+{
+  std::vector<CDomain*> domainListDestP = gridDst->getDomains();
+  std::vector<CDomain*> domainListSrcP  = gridSrc->getDomains();
+
+  CReorderDomain* reorderDomain = dynamic_cast<CReorderDomain*> (transformation);
+  int domainDstIndex = elementPositionInGridDst2DomainPosition[elementPositionInGrid];
+  int domainSrcIndex = elementPositionInGridSrc2DomainPosition[elementPositionInGrid];
+
+  return (new CDomainAlgorithmReorder(domainListDestP[domainDstIndex], domainListSrcP[domainSrcIndex], reorderDomain));
+}
+
+bool CDomainAlgorithmReorder::registerTrans()
+{
+  CGridTransformationFactory<CDomain>::registerTransformation(TRANS_REORDER_DOMAIN, create);
+}
+
+CDomainAlgorithmReorder::CDomainAlgorithmReorder(CDomain* domainDestination, CDomain* domainSource, CReorderDomain* reorderDomain)
+: CDomainAlgorithmTransformation(domainDestination, domainSource)
+{
+  reorderDomain->checkValid(domainSource);
+  if (domainDestination->type !=  CDomain::type_attr::rectilinear)
+  {
+      ERROR("CDomainAlgorithmReorder::CDomainAlgorithmReorder(CDomain* domainDestination, CDomain* domainSource, CReorderDomain* reorderDomain)",
+           << "Domain destination is not rectilinear. This filter work only for rectilinear domain and destination domain with < id = "
+           <<domainDestination->getId() <<" > is of type "<<domainDestination->type<<std::endl);
+  }
+  
+  if (domainDestination == domainSource)
+  {
+    ERROR("CDomainAlgorithmReorder::CDomainAlgorithmReorder(CDomain* domainDestination, CDomain* domainSource, CReorderDomain* reorderDomain)",
+           << "Domain source and domain destination are the same. Please make sure domain destination refers to domain source" << std::endl
+           << "Domain source " <<domainSource->getId() << std::endl
+           << "Domain destination " <<domainDestination->getId() << std::endl);
+  }
+  this->type_ = (ELEMENT_MODIFICATION_WITHOUT_DATA);
+
+  if (!reorderDomain->invert_lat.isEmpty())
+  {
+    CArray<int,1>& j_index=domainDestination->j_index ;
+    int nglo = j_index.numElements() ;
+    int nj_glo =domainDestination->nj_glo ;
+    
+    for (size_t i = 0; i < nglo ; ++i)
+    {
+      j_index(i)=(nj_glo-1)-j_index(i) ;
+    }
+  }
+
+  if (!reorderDomain->shift_lon_fraction.isEmpty())
+  {
+    int ni_glo =domainDestination->ni_glo ;
+    int  offset = ni_glo*reorderDomain->shift_lon_fraction ;
+    CArray<int,1>& i_index=domainDestination->i_index ;
+    int nglo = i_index.numElements() ;
+    
+    for (size_t i = 0; i < nglo ; ++i)
+    {
+      i_index(i)=  (i_index(i)+offset+ni_glo)%ni_glo ;
+    }
+  }
+
+  if (!reorderDomain->min_lon.isEmpty() && !reorderDomain->max_lon.isEmpty())
+  {
+    double min_lon=reorderDomain->min_lon ;
+    double max_lon=reorderDomain->max_lon ;
+    double delta=max_lon-min_lon ;
+    
+    if (!domainDestination->lonvalue_1d.isEmpty() )
+    {
+      CArray<double,1>& lon=domainDestination->lonvalue_1d ;
+      for (int i=0;i<lon.numElements();++i)
+      {
+        while  (lon(i) > max_lon) lon(i)=lon(i)-delta ;
+        while  (lon(i) < min_lon) lon(i)=lon(i)+delta ;
+      }
+    }
+
+    if (!domainDestination->bounds_lon_1d.isEmpty() )
+    {
+      CArray<double,2>& bounds_lon=domainDestination->bounds_lon_1d ;
+      for (int i=0;i<bounds_lon.extent(0);++i)
+      {
+        while  (bounds_lon(0,i) > max_lon) bounds_lon(0,i)=bounds_lon(0,i)-delta ;
+        while  (bounds_lon(1,i) > max_lon) bounds_lon(1,i)=bounds_lon(1,i)-delta ;
+
+        while  (bounds_lon(0,i) < min_lon) bounds_lon(0,i)=bounds_lon(0,i)+delta ;
+        while  (bounds_lon(1,i) < min_lon) bounds_lon(1,i)=bounds_lon(1,i)+delta ;
+      }
+    }
+  }
+    
+  
+}
+
+/*!
+  Compute the index mapping between domain on grid source and one on grid destination
+*/
+void CDomainAlgorithmReorder::computeIndexSourceMapping_(const std::vector<CArray<double,1>* >& dataAuxInputs)
+{
+/*
+  this->transformationMapping_.resize(1);
+  this->transformationWeight_.resize(1);
+
+  TransformationIndexMap& transMap = this->transformationMapping_[0];
+  TransformationWeightMap& transWeight = this->transformationWeight_[0];
+*/
+}
+
+
+}
Index: /XIOS/trunk/src/transformation/domain_algorithm_reorder.hpp
===================================================================
--- /XIOS/trunk/src/transformation/domain_algorithm_reorder.hpp	(revision 1537)
+++ /XIOS/trunk/src/transformation/domain_algorithm_reorder.hpp	(revision 1537)
@@ -0,0 +1,46 @@
+/*!
+   \brief Algorithm for reordering domain.
+ */
+#ifndef __XIOS_DOMAIN_ALGORITHM_REORDER_HPP__
+#define __XIOS_DOMAIN_ALGORITHM_REORDER_HPP__
+
+#include "domain_algorithm_transformation.hpp"
+#include "transformation.hpp"
+
+namespace xios {
+
+class CDomain;
+class CReorderDomain;
+
+/*!
+  \class CDomainAlgorithmReorder
+  Reordering data on domain
+*/
+class CDomainAlgorithmReorder : public CDomainAlgorithmTransformation
+{
+public:
+  CDomainAlgorithmReorder(CDomain* domainDestination, CDomain* domainSource, CReorderDomain* reorderDomain);
+
+  virtual ~CDomainAlgorithmReorder() {}
+
+  static bool registerTrans();
+
+protected:
+  void computeIndexSourceMapping_(const std::vector<CArray<double,1>* >& dataAuxInputs);
+
+
+private:
+
+  static CGenericAlgorithmTransformation* create(CGrid* gridDst, CGrid* gridSrc,
+                                                CTransformation<CDomain>* transformation,
+                                                int elementPositionInGrid,
+                                                std::map<int, int>& elementPositionInGridSrc2ScalarPosition,
+                                                std::map<int, int>& elementPositionInGridSrc2AxisPosition,
+                                                std::map<int, int>& elementPositionInGridSrc2DomainPosition,
+                                                std::map<int, int>& elementPositionInGridDst2ScalarPosition,
+                                                std::map<int, int>& elementPositionInGridDst2AxisPosition,
+                                                std::map<int, int>& elementPositionInGridDst2DomainPosition);
+};
+
+}
+#endif // __XIOS_DOMAIN_ALGORITHM_REORDER_HPP__
Index: /XIOS/trunk/src/transformation/domain_algorithm_transformation.cpp
===================================================================
--- /XIOS/trunk/src/transformation/domain_algorithm_transformation.cpp	(revision 1536)
+++ /XIOS/trunk/src/transformation/domain_algorithm_transformation.cpp	(revision 1537)
@@ -48,11 +48,15 @@
   CClientClientDHTInt::Index2VectorInfoTypeMap globalIndex2ProcRank;
   globalIndex2ProcRank.rehash(std::ceil(nIndexSize/globalIndex2ProcRank.max_load_factor()));
+  CArray<bool,1>& localMask=domainSrc_->localMask ;
   for (int idx = 0; idx < nIndexSize; ++idx)
   {
-    i_ind=domainSrc_->i_index(idx) ;
-    j_ind=domainSrc_->j_index(idx) ;
+    if (localMask(idx))
+    {
+      i_ind=domainSrc_->i_index(idx) ;
+      j_ind=domainSrc_->j_index(idx) ;
 
-    globalIndex = i_ind + j_ind * niGlob;
-    globalIndex2ProcRank[globalIndex].push_back(clientRank);
+      globalIndex = i_ind + j_ind * niGlob;
+      globalIndex2ProcRank[globalIndex].push_back(clientRank);
+    }
   }
 
